package cn.iocoder.yudao.module.mes.dal.mysql.repairtems;

import java.util.*;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.mes.dal.dataobject.repairtems.RepairTemsDO;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.mes.controller.admin.repairtems.vo.*;
import org.apache.ibatis.annotations.Param;

/**
 * 维修项目 Mapper
 *
 * @author 内蒙必硕
 */
@Mapper
public interface RepairTemsMapper extends BaseMapperX<RepairTemsDO> {

    default PageResult<RepairTemsDO> selectPage(RepairTemsPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<RepairTemsDO>()
                .eqIfPresent(RepairTemsDO::getSubjectCode, reqVO.getSubjectCode())
                .likeIfPresent(RepairTemsDO::getSubjectName, reqVO.getSubjectName())
                .eqIfPresent(RepairTemsDO::getDeviceType, reqVO.getDeviceType())
                .eqIfPresent(RepairTemsDO::getDeviceId, reqVO.getDeviceId())
                .eqIfPresent(RepairTemsDO::getComponentId, reqVO.getComponentId())
                .eqIfPresent(RepairTemsDO::getInspectionMethod, reqVO.getInspectionMethod())
                .eqIfPresent(RepairTemsDO::getValueType, reqVO.getValueType())
                .eqIfPresent(RepairTemsDO::getJudgmentCriteria, reqVO.getJudgmentCriteria())
                .eqIfPresent(RepairTemsDO::getIsEnable, reqVO.getIsEnable())
                .betweenIfPresent(RepairTemsDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(RepairTemsDO::getId));
    }

    IPage<RepairTemsRespVO> getRepairTemsPage(Page<RepairTemsRespVO> page,  @Param("pageReqVO") RepairTemsPageReqVO pageReqVO);

    List<RepairTemsRespVO> getRepairTemsList( @Param("pageReqVO") RepairTemsPageReqVO pageReqVO);

}